<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~assign_barcode.js,~pools.js,~plate.js" 
	styles="path.css,~../css/reggie-2.css,~../css/plate.css">
<style>
#select-barcode-all
{
	max-height: 20em;
	overflow: auto;
}

#select-barcode .menuitem
{
	padding-left: 16px;
}

#select-barcode div.current
{
	font-weight: bold;
	background-image: url('../images/selected.gif');
	background-position: 2px 50%;
	background-repeat: no-repeat;
}

#select-barcode .menuitem:hover
{
	padding-left: 14px;
	background-position: 0px 50%;
}

.menuseparator
{
	width: auto !important;
}

.well.primary.empty
{
	background-color: #F0F0F0;
}

.yellow-specimen .if-yellow
{
	background-image: url('../images/yellow-label-small.png');
	background-position: 1px 50%;
	background-repeat: no-repeat;
	/* Grow background without shifting text position veritcally, move to right to make room for icon*/
	padding: 2px 2px 2px 14px;
	margin: -2px;
}

</style>
</base:head>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Assign barcodes to cDNA plates" 
		/></p:path>

	<div class="content">

	<form name="reggie" id="wizard" class="wizard">

	<div id="select-barcode" class="menu vertical bg-filled-100" style="width: 15em; z-index: 2; display: none;">
		<div class="menuitem interactable enabled" id="select-barcode-default">Default</div>
		<div class="menuseparator" id="select-barcode-default-separator"></div>
		<div id="select-barcode-all"></div>
	</div>
	
	<div class="step auto-hide" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select cDNA bioplate</div>
		<div class="step-content">

			<table class="step-form">
			<tr>
				<td class="prompt">cDNA bioplate</td>
				<td class="input">
					<select class="required" name="bioplate" id="bioplate"></select>					
				</td>
				<td class="status" id="bioplate.status"></td>
				<td class="help">
					<span id="bioplate.message" class="message"></span>
					Select an existing cDNA bioplate. The list contain all cDNA bioplates that
					has not yet been assigned barcodes (determined by the absence of 'BarcodeVariant' 
					annotation).
				</td>
			</tr>
			<tbody class="info-section">
			<tr>
				<td class="prompt">Comments</td>
				<td class="info" id="cdnaComments" colspan="2"></td>
				<td class="help"></td>
			</tr>
			</tbody>
			</table>
		</div>
	</div>
	
	<div class="step" id="step-2">
		<div class="step-no">2</div>
		<div class="step-title">Select barcodes</div>
		<div class="step-content">
		
			<table class="step-form bottomborder">
			<tr>
				<td class="prompt">Pool layout</td>
				<td class="input">
					<select name="pool_schema" id="pool_schema" class="required"></select>
				</td>
				<td class="help"></td>
			</tr>
			<tr>
				<td class="prompt">Barcode variants</td>
				<td class="input">
					<select name="barcode_variant" id="barcode_variant" class="required"></select>
				</td>
				<td class="help"></td>
			</tr>
			<tr class="align-top">
				<td class="prompt">Comments</td>
				<td class="input">
					<textarea rows="2" name="comments" id="comments"></textarea>
				</td>
				<td class="help">Comments for the library preparation.</td>
			</tr>
			</table>
			
			<table class="plate" style="margin: 1em auto 1em auto;" id="plate">
			<%
			int columns = 12;
			int rows = 8;
			WellCoordinateFormatter rowF = new WellCoordinateFormatter(true);
			WellCoordinateFormatter colF = new WellCoordinateFormatter(false);
			%>
			<tr class="header">
				<th></th>
				<%
				for (int c = 0; c < columns; ++c)
				{
					%>
					<th id="col.<%=c%>"><%=colF.format(c)%></th>
					<%
				}
				%>
			</tr>
			<tbody>
			<%
			for (int r = 0; r < rows; ++r)
			{
				String row = rowF.format(r);
				%>
				<tr class="row-<%=r%>">
					<th id="row.<%=r%>" class="rowheader"><%=row%></th>
					<%
					for (int c = 0; c < columns; ++c)
					{
						%>
						<td class="well col-<%=c%>" id="well.<%=r%>.<%=c%>"
							data-row="<%=r%>" data-col="<%=c%>"
							title="Click to select barcode for this well"
							></td>
						<%
					}
					%>
				</tr>
				<%
			}
			%>
			</tbody>
			<tr id="pool-row">
				<th colspan="13">&nbsp;</th>
			</tr>
			</table>
		</div>
	</div>
	
	<div id="wizard-status"></div>
	
	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>"  /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>